#!/usr/bin/env ruby

# Structure of the .json with interactions:
#
# [
#   {"user_id": "user-50",  "item_id": "event-276", "timestamp": "2016-04-20T12:50:42+02:00"},
#   {"user_id": "user-389", "item_id": "event-73",  "timestamp": "2014-07-20T02:49:45+02:00"},
#   {"user_id": "user-204", "item_id": "event-116", "timestamp": "2015-04-22T13:32:32+02:00"},
#   ...
# ]

require 'recombee_api_client'
include RecombeeApiClient

require 'json'

client = RecombeeClient.new('events-example', 'PbBaEVxx8ZOj0x3BhGtqfHyi8qQ8rm8rE1JBnSPoCnHwetzO3gjHer96YVAIa14G')

interactions = []

file = File.read('detail_views.json')
JSON.parse(file).each do |interaction|
  user_id = interaction['user_id']
  item_id = interaction['item_id']
  time = interaction['timestamp']
  r = AddDetailView.new(user_id, item_id, 'timestamp' => time, 'cascadeCreate' => true)
  interactions.push(r)
end

br = Batch.new(interactions)
client.send(br)

recommended = client.send(RecommendItemsToUser.new('user-27', 5))
puts(recommended)

recommended = client.send(RecommendItemsToItem.new('event-32', 'user-27', 5))
puts(recommended)

recommended = client.send(RecommendUsersToItem.new('event-42', 5))
puts(recommended)